/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 2808_CDPSTPO_BUSCA_CUSTO_RECEITA.SQL

Descrio:
   Funo para buscar o custo da receita do produto de acordo com as variaes  do preo da matria prima

Criao:
04/12/2009 - Welbert G. Moitinha
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'BUSCA_CUSTO_RECEITA' AND
                 TYPE = 'P' 		      AND
	              U.UID = O.UID           AND
	              U.NAME = USER)
DROP PROCEDURE BUSCA_CUSTO_RECEITA
GO

CREATE PROCEDURE BUSCA_CUSTO_RECEITA @P_IDOPCAO VARCHAR(1),
                                     @P_CDFILIAL VARCHAR(4),
                                     @P_NRTIPOCUSTO INT,
                                     @P_NRSEQDIFCUST  VARCHAR(10) OUTPUT
AS

   DECLARE @V_CUSTOATUAL DOUBLE PRECISION;
   DECLARE @V_VRHISCUSTOPROD DOUBLE PRECISION;
   DECLARE @V_VRHISPRECOPROD DOUBLE PRECISION;
   DECLARE @V_VRPERCDIFECUS DOUBLE PRECISION;
   DECLARE @V_VRCALCCUSTO DOUBLE PRECISION;
   DECLARE @V_VRPERDIFCUSPREC DOUBLE PRECISION;
   DECLARE @V_STNUMERO VARCHAR(20);
   DECLARE @V_COUNT INT;
   DECLARE @C_PRODACAB_CDPRODUTO VARCHAR(10);
   DECLARE @C_PRODACAB_CDPROCFABRIC VARCHAR(10);
   DECLARE @C_PRODACAB_DTVALPROFABR DATETIME;
   DECLARE @V_SEQ VARCHAR(19);
   DECLARE @C_INSUMOS_IDSEMIACETAP VARCHAR(1);
   DECLARE @C_INSUMOS_CDPRODINSUMO VARCHAR(10);
   DECLARE @V_IDTPVARATUPRECO VARCHAR2(1);

BEGIN
   SET @V_VRPERCDIFECUS = 0;
   SET @V_CUSTOATUAL =0;


   SELECT @V_VRPERDIFCUSPREC = ISNULL(MAX(VRPERDIFCUSPREC),0),
          @V_IDTPVARATUPRECO = ISNULL(IDTPVARATUPRECO,'P')
     FROM PARAMPEDIDO
    WHERE CDFILIAL = @P_CDFILIAL;


/* BUSCA SEQUENCIAL DA TABELE DE TRABALHO */
    SET @V_SEQ =  ('TRABDIFCUSTPROD'+@P_CDFILIAL);
    EXEC NOVO_CODIGO_SC @V_SEQ , @V_STNUMERO OUTPUT, 1;
    SET @V_STNUMERO = SUBSTRING( @V_STNUMERO,11,10);


/* BUSCA PRODUTOS ACABADOS */

   DECLARE  C_PRODACAB CURSOR FOR
                       SELECT
                          CDPRODUTO,
                          CDPROCFABRIC,
                          DTVALPROFABR
                       FROM PROCFABRICA
                       WHERE
                          CDFILIAL = @P_CDFILIAL AND
                          IDPROFABPADR = 'S';


   OPEN C_PRODACAB;
   FETCH NEXT FROM C_PRODACAB INTO @C_PRODACAB_CDPRODUTO,
                                   @C_PRODACAB_CDPROCFABRIC,
                                   @C_PRODACAB_DTVALPROFABR;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @P_IDOPCAO = 'I' BEGIN
         SET @V_CUSTOATUAL = 0;
         SET @V_VRCALCCUSTO = 0;


         DECLARE C_INSUMOS CURSOR FOR
                           SELECT ISNULL(IDSEMIACETAP,'N')AS IDSEMIACETAP, CDPRODINSUMO
                             FROM   INSUMETAPA
                            WHERE
                                 CDFILIAL  =  @P_CDFILIAL AND
                                 CDPRODUTO =  @C_PRODACAB_CDPRODUTO AND
                                 CDPROCFABRIC = @C_PRODACAB_CDPROCFABRIC;


         OPEN C_INSUMOS;
         FETCH NEXT FROM C_INSUMOS INTO  @C_INSUMOS_IDSEMIACETAP, @C_INSUMOS_CDPRODINSUMO;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            SET @V_CUSTOATUAL = ROUND( TEKNISA.CUSTO_PRODUTO( @P_CDFILIAL, @C_INSUMOS_CDPRODINSUMO, @P_NRTIPOCUSTO, GETDATE(), GETDATE()),2)+ @V_CUSTOATUAL;
            FETCH NEXT FROM C_INSUMOS INTO  @C_INSUMOS_IDSEMIACETAP, @C_INSUMOS_CDPRODINSUMO;
         END;
         CLOSE C_INSUMOS;
         DEALLOCATE C_INSUMOS;

         /* BUSCA O CUSTO ANTERIOR  */
         SELECT @V_VRHISCUSTOPROD = ISNULL(MAX(VRHISCUSTOPROD),0),
                @V_VRHISPRECOPROD = ISNULL(MAX(VRHISPRECOPROD),0)
           FROM HISTCUSTOPROD
          WHERE
            CDFILIALHIST = @P_CDFILIAL AND
            CDPRODUTOHIST = @C_PRODACAB_CDPRODUTO;

         IF ISNULL(@V_CUSTOATUAL,0) > 0 BEGIN
            IF ISNULL(@V_IDTPVARATUPRECO,'P') = 'P' BEGIN
               /* TESTA A DIFERENA*/
               SET @V_VRCALCCUSTO =  ABS( ISNULL(@VRHISPRECOPROD,0) - ISNULL(@V_CUSTOATUAL,0));
  
               IF(@V_VRCALCCUSTO * 100 / ISNULL(@VRHISPRECOPROD,1)) >= (@V_VRPERDIFCUSPREC/100) BEGIN
                  INSERT INTO TRABDIFCUSTPROD( NRSEQDIFCUST, CDFILIALTRAB, CDPRODUTOTRAB, VRCUSTANTPROD, VRCUSTATUPROD, VRPERDIFCUSTPRO)
                                        VALUES( @V_STNUMERO, @P_CDFILIAL, @C_PRODACAB_CDPRODUTO, @VRHISPRECOPROD, @V_CUSTOATUAL, (@V_VRCALCCUSTO * 100 / ISNULL(@VRHISPRECOPROD,1)));
            END
            ELSE BEGIN
               /* TESTA A DIFERENA*/
               SET @V_VRCALCCUSTO =  ABS( ISNULL(@V_VRHISCUSTOPROD,0) - ISNULL(@V_CUSTOATUAL,0));
  
               IF(@V_VRCALCCUSTO * 100 / ISNULL(@V_VRHISCUSTOPROD,1)) >= (@V_VRPERDIFCUSPREC/100) BEGIN
                  INSERT INTO TRABDIFCUSTPROD( NRSEQDIFCUST, CDFILIALTRAB, CDPRODUTOTRAB, VRCUSTANTPROD, VRCUSTATUPROD, VRPERDIFCUSTPRO)
                                        VALUES( @V_STNUMERO, @P_CDFILIAL, @C_PRODACAB_CDPRODUTO, @V_VRHISCUSTOPROD, @V_CUSTOATUAL, (@V_VRCALCCUSTO * 100 / ISNULL(@V_VRHISCUSTOPROD,1)));
            END;
         END;
      END
      ELSE BEGIN
         SET @V_CUSTOATUAL = 0;
         SET @V_VRCALCCUSTO = 0;

         /* BUSCA O CUSTO ANTERIOR */
        SELECT @V_VRHISCUSTOPROD = ISNULL(MAX(VRHISCUSTOPROD),0),
                @V_VRHISPRECOPROD = ISNULL(MAX(VRHISPRECOPROD),0)
           FROM HISTCUSTOPROD
          WHERE
            CDFILIALHIST = @P_CDFILIAL AND
            CDPRODUTOHIST = @C_PRODACAB_CDPRODUTO;

         SET @V_CUSTOATUAL = ROUND( TEKNISA.CUSTO_PRODUTO( @P_CDFILIAL, @C_PRODACAB_CDPRODUTO, @P_NRTIPOCUSTO, GETDATE(), GETDATE()),2);

         IF @V_CUSTOATUAL >0 BEGIN
            IF ISNULL(@V_IDTPVARATUPRECO,'P') = 'P' BEGIN
               /* TESTA A DIFERENA*/
               IF ISNULL(@V_VRHISPRECOPROD,0)> 0 BEGIN
                  SET @V_VRCALCCUSTO =  ABS( ISNULL(@V_VRHISPRECOPROD,0) - ISNULL(@V_CUSTOATUAL,0));
                  IF(@V_VRCALCCUSTO * 100 / ISNULL(@V_VRHISPRECOPROD,1)) >= (@V_VRPERDIFCUSPREC/100) BEGIN
                     INSERT INTO TRABDIFCUSTPROD( NRSEQDIFCUST, CDFILIALTRAB, CDPRODUTOTRAB, VRCUSTANTPROD, VRCUSTATUPROD, VRPERDIFCUSTPRO)
                                           VALUES( @V_STNUMERO, @P_CDFILIAL, @C_PRODACAB_CDPRODUTO, @V_VRHISPRECOPROD, @V_CUSTOATUAL, (@V_VRCALCCUSTO * 100 / ISNULL(@V_VRHISPRECOPROD,1)));
                  END;
               END
               ELSE BEGIN
                  INSERT INTO TRABDIFCUSTPROD( NRSEQDIFCUST, CDFILIALTRAB, CDPRODUTOTRAB, VRCUSTANTPROD, VRCUSTATUPROD, VRPERDIFCUSTPRO)
                                           VALUES( @V_STNUMERO, @P_CDFILIAL, @C_PRODACAB_CDPRODUTO, @V_VRHISPRECOPROD, @V_CUSTOATUAL, (@V_VRCALCCUSTO * 100 / ISNULL(@V_VRHISPRECOPROD,1)));
               END;
            END
            ELSE BEGIN
               /* TESTA A DIFERENA*/
               IF ISNULL(@V_VRHISCUSTOPROD,0)> 0 BEGIN
                  SET @V_VRCALCCUSTO =  ABS( ISNULL(@V_VRHISCUSTOPROD,0) - ISNULL(@V_CUSTOATUAL,0));
                  IF(@V_VRCALCCUSTO * 100 / ISNULL(@V_VRHISCUSTOPROD,1)) >= (@V_VRPERDIFCUSPREC/100) BEGIN
                     INSERT INTO TRABDIFCUSTPROD( NRSEQDIFCUST, CDFILIALTRAB, CDPRODUTOTRAB, VRCUSTANTPROD, VRCUSTATUPROD, VRPERDIFCUSTPRO)
                                           VALUES( @V_STNUMERO, @P_CDFILIAL, @C_PRODACAB_CDPRODUTO, @V_VRHISCUSTOPROD, @V_CUSTOATUAL, (@V_VRCALCCUSTO * 100 / ISNULL(@V_VRHISCUSTOPROD,1)));
                  END;
               END
               ELSE BEGIN
                  INSERT INTO TRABDIFCUSTPROD( NRSEQDIFCUST, CDFILIALTRAB, CDPRODUTOTRAB, VRCUSTANTPROD, VRCUSTATUPROD, VRPERDIFCUSTPRO)
                                           VALUES( @V_STNUMERO, @P_CDFILIAL, @C_PRODACAB_CDPRODUTO, @V_VRHISCUSTOPROD, @V_CUSTOATUAL, (@V_VRCALCCUSTO * 100 / ISNULL(@V_VRHISCUSTOPROD,1)));
               END;
            END;
         END;
      END;
      FETCH NEXT FROM C_PRODACAB INTO @C_PRODACAB_CDPRODUTO, @C_PRODACAB_CDPROCFABRIC, @C_PRODACAB_DTVALPROFABR;
   END;
   CLOSE C_PRODACAB;
   DEALLOCATE C_PRODACAB;
   SET @P_NRSEQDIFCUST = @V_STNUMERO;
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'BUSCA_CUSTO_RECEITA','6.19.000';
GO

